Imports Banking.Library.Service.Interfaces
Imports Banking.Library.Service
Imports Banking.Library.Entity
Imports NHibernate
Imports NHibernate.Linq
Imports System.IO
Imports System.Text
Imports System

<HandleError()> _
Public Class UserController
    Inherits System.Web.Mvc.Controller

    '
    ' GET: /User/

    Function Index() As ActionResult
        Dim UserList As List(Of User)
        Dim mSession As ISession
        Dim mSessionFactory As ISessionFactory

        Dim configuration = New Cfg.Configuration()

        configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking.Test\app.config")
        'configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking\Web.config")

        mSessionFactory = configuration.BuildSessionFactory()

        mSession = mSessionFactory.OpenSession()

        Try
            mSession.BeginTransaction()

            'do our first query using LINQ to NHibernate
            Dim query As IQueryable(Of User) = From Item In mSession.Linq(Of User)() _
                                               Select Item

            query = query.Where(Function(x) x.State.Equals("IA"))

            UserList = query.ToList()

            mSession.Transaction.Commit()
        Catch ex As Exception
            mSession.Transaction.Rollback()
        Finally
            mSession.Close()
        End Try

        Return View(UserList)
    End Function

    '
    ' GET: /User/Edit

    Function Edit(ByVal id As Integer) As ActionResult
        Dim User As User = Nothing
        Dim mSession As ISession
        Dim mSessionFactory As ISessionFactory

        Dim configuration = New Cfg.Configuration()

        configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking.Test\app.config")
        'configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking\Web.config")

        mSessionFactory = configuration.BuildSessionFactory()

        mSession = mSessionFactory.OpenSession()

        Try
            mSession.BeginTransaction()

            'do our first query
            User = mSession.Get(Of User)(id)

            mSession.Transaction.Commit()
        Catch ex As Exception
            mSession.Transaction.Rollback()
        Finally
            mSession.Close()
        End Try

        Return View(User)
    End Function

    '
    ' POST: /User/Edit/1

    <AcceptVerbs(HttpVerbs.Post)> _
    Function Edit(ByVal id As Integer, ByVal collection As FormCollection) As ActionResult
        Dim User As User
        Dim mSession As ISession
        Dim mSessionFactory As ISessionFactory

        Dim configuration = New Cfg.Configuration()

        configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking.Test\app.config")
        'configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking\Web.config")

        mSessionFactory = configuration.BuildSessionFactory()

        mSession = mSessionFactory.OpenSession()

        Try
            mSession.BeginTransaction()

            'first query to get the user as it exists in the database
            User = mSession.Get(Of User)(1)

            'next update the address property
            User.Address = "1016 Cameron"

            Dim NewUser As New User With {.ID = 0, .FirstName = "John", .LastName = "Doe", .Address = "400 N. 1st", .City = "Des Moines", .State = "IA", .Zip = "50309", .Phone = "5154010344"}

            'the below is optional, not required for the session to persist changes
            'mSession.SaveOrUpdate(User)

            mSession.Transaction.Commit()
        Catch ex As Exception
            mSession.Transaction.Rollback()
        Finally
            mSession.Close()
        End Try

        Return View(User)
    End Function

    '
    ' POST: /User/Delete/1

    <AcceptVerbs(HttpVerbs.Post)> _
    Function Delete(ByVal id As Integer) As ActionResult
        Dim User As User
        Dim mSession As ISession
        Dim mSessionFactory As ISessionFactory

        Dim configuration = New Cfg.Configuration()

        configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking.Test\app.config")
        'configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking\Web.config")

        mSessionFactory = configuration.BuildSessionFactory()

        mSession = mSessionFactory.OpenSession()

        Try
            mSession.BeginTransaction()

            'first query to get the user as it exists in the database
            User = mSession.Get(Of User)(1)

            'next tell NHibernate to delete this user
            mSession.Delete(User)

            mSession.Transaction.Commit()
        Catch ex As Exception
            mSession.Transaction.Rollback()
        Finally
            mSession.Close()
        End Try

        Return View()
    End Function

    '
    ' POST: /User/Create/1

    <AcceptVerbs(HttpVerbs.Post)> _
    Function Create(ByVal collection As FormCollection) As ActionResult
        Dim User As User
        Dim mSession As ISession
        Dim mSessionFactory As ISessionFactory

        Dim configuration = New Cfg.Configuration()

        configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking.Test\app.config")
        'configuration.Configure("C:\Documents and Settings\User\My Documents\Visual Studio 2008\Projects\Banking\Banking\Web.config")

        mSessionFactory = configuration.BuildSessionFactory()

        mSession = mSessionFactory.OpenSession()

        Try
            mSession.BeginTransaction()

            Dim NewUser As New User With {.FirstName = "John", .LastName = "Doe", .Address = "400 N. 1st", .City = "Des Moines", .State = "IA", .Zip = "50309", .Phone = "5154010344"}

            mSession.SaveOrUpdate(NewUser)

            mSession.Transaction.Commit()
        Catch ex As Exception
            mSession.Transaction.Rollback()
        Finally
            mSession.Close()
        End Try

        Return View()
    End Function

End Class
